import pygame,  sys
import data.engine as e
from pygame.locals import *

clock = pygame.time.Clock()

pygame.mixer.pre_init(44100, -16, 2, 2048) # need to initilize sound before pygame
pygame.init() # initiates pygame
pygame.mixer.set_num_channels(64)
pygame.display.set_caption('game')

# get the size of the users montitor before setting display mode
monitor_size = (pygame.display.Info().current_w, pygame.display.Info().current_h)

# window_size is the current size of the resizable game window 
# screen_size is the size of the resizable window when not full screen
# SIZE is the size of the scalable visible area
screen_size = window_size = SIZE = (1280,720)

screen = pygame.display.set_mode(window_size, pygame.RESIZABLE) # initiate the window

display = pygame.Surface(SIZE) # used as the surface for rendering, which is scaled


fullscreen = False
moving_right = False
moving_left = False
jumping = False
display_invent = False
vertical_momentum = 0
jumping_momentum = 0
momentum = 0
SPEED = 5
alive = True
air_timer = 0
invent = {"Gold": 0, "Keys": 0}
keys = [] #pressed keys for controls
screenText = "" #Text to display on screen
screenTextTimer = 0 
font1 = pygame.font.SysFont('comicsans', 100)
font2 = pygame.font.SysFont('comicsans', 30)

class thing(object):
    def __init__(self,x,y, dx, dy, sx, sy, img, name):
        self.x = x
        self.y = y
        self.hitBox = pygame.Rect(x + dx,y + dy,sx,sy)
        self.img = img
        self.name = name

class bug(object):
    def __init__(self,ent, momentum):
        self.ent = ent
        self.momentum = momentum
        if ent.type == 'ball':
            self.killable = False
        else:
            self.killable = True

class level(object):
    def __init__(self,map,music,bg):
        self.map = map
        self.music = music
        self.bg = bg

levels = []
f = open('data/levels.txt','r')
data = f.read()
f.close()
data = data.split('\n')
for r in data:
    c = r.split(',')
    levels.append(level(c[0], c[1], c[2]))

#levels = [level("map","background-music.mp3", "bg.png" ),level("map2","background-music.mp3", "bg.png" )]

def load_map(path):
    f = open(path + '.txt','r')
    data = f.read()
    f.close()
    data = data.split('\n')
    game_map = []
    for row in data:
        game_map.append(list(row))
    return game_map

e.load_animations('data/images/entities/')

player_action = 'idle'
player_flip = False
door_unlocked = False

player = e.entity(640,400,27,50,'player')

floor_img = pygame.image.load('data/images/rocks top.png')
solid_img = pygame.image.load('data/images/gray plain.png')
spikes1_img = pygame.image.load('data/images/spikes1.png')
gold_img = pygame.image.load('data/images/coin.png')
key_img = pygame.image.load('data/images/key.png')
door_img = pygame.image.load('data/images/locked door.png')
unlocked_door_img = pygame.image.load('data/images/door.png')
stairs_img = pygame.image.load('data/images/stairs.png')

jumpSound = pygame.mixer.Sound('data/sounds/jump.wav')
spikeSound = pygame.mixer.Sound('data/sounds/mud-splat.wav')
goldSound = pygame.mixer.Sound('data/sounds/ding.wav')
splatSound = pygame.mixer.Sound('data/sounds/splat.wav')

bgMovex = bgMovey = 0
bgSize= (0, 0)
background = pygame.Surface((100, 100))
tile_rects = []
kill_tiles = []
items = []
monsters = []
start_pos = (0, 0)
current_level = 0

#TODO handle resize events?
def splash_screen():# Splash Sreen
    splash = pygame.image.load('data/images/splash.png')
    screen.blit(splash,(0,0))
    pygame.display.update()
    startScreen = True
    while startScreen == True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                startScreen = False
                pygame.quit()
            if event.type == KEYDOWN:
                startScreen = False


def end_screen():# Splash Sreen
    global window_size
    end_surface = pygame.Surface(SIZE)
    end_splash = pygame.image.load('data/images/end_splash.png')
    end_surface.blit(end_splash,(0,0))
    text = font1.render("Gold  " + str(invent["Gold"]),1,(200,200,0) )
    end_surface.blit(text, (520,350))
    end_surface = pygame.transform.scale(end_surface, window_size)
    screen.blit(end_surface,(0,0))
    pygame.display.update()
    startScreen = True
    while startScreen == True:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                pygame.quit()
            if event.type == KEYDOWN:
                if event.key == K_q:
                    pygame.quit()
                if event.key == K_s:
                    startScreen = False
                if event.key == K_ESCAPE or event.key == K_RETURN:
                    window_size = screen_size
                    pygame.display.set_mode(window_size, pygame.RESIZABLE)

    
def load_level(level):
    global start_pos
    global bgSize
    global background
    
    map_path = 'data/' + level.map
    img_path = 'data/images/' + level.bg
    music_path = 'data/sounds/' + level.music
    pygame.mixer.music.load(music_path)
    pygame.mixer.music.set_volume(0.2)
    pygame.mixer.music.play(-1)

    game_map = load_map(map_path)
    bgSize = (len(game_map[0]) * 64, len(game_map) * 64)
    bg = pygame.image.load(img_path)
    bg = pygame.transform.scale(bg, bgSize)
    
    background = pygame.Surface(bgSize) # used as the surface for rendering static objects
    background.blit(bg,(0,0))
    
    global tile_rects
    global kill_tiles
    global items
    global monsters
    tile_rects = []
    kill_tiles = []
    items = []
    monsters = []
    blocks = {}
    kills = {}
    fills = {}
    entities = {}
    others = {}
    f = open('data/legend.txt','r')
    data = f.read()
    f.close()
    data = data.split('\n')
    for r in data:
        c = r.split(';')
        if len(c) >= 3:
            if c[2] == 's':
                blocks[c[0]] = c[1]
            elif c[2] == 'k':
                kills[c[0]] = c[1]
            elif c[2] == 'o':
                fills[c[0]] = c[1]
            elif c[2] == 'e':
                entities[c[0]] = [c[1], c[2], c[3], c[4]]
            else:
                others[c[0]] = (c[1], c[2])
    y = 0
    for layer in game_map:
        x = 0
        for tile in layer:
            for b in blocks:
                if tile == b:
                    background.blit(pygame.image.load('data/images/' + blocks[b]),(x*64,y*64))
                    tile_rects.append(pygame.Rect(x*64,y*64,64,64))
            for k in kills:
                if tile == k:
                    background.blit(pygame.image.load('data/images/' + kills[k]),(x*64,y*64))
                    kill_tiles.append(pygame.Rect(x*64,y*64,64,64))
            for f in fills:
                if tile == f:
                    background.blit(pygame.image.load('data/images/' + fills[f]),(x*64,y*64))
            for ent in entities:
                if tile == ent:
                    monsters.append(bug(e.entity((x * 64),(y * 64) + 64 - int(entities[ent][3]),int(entities[ent][2]),int(entities[ent][3]),entities[ent][0].split('.')[0]), 3))
            for o in others:
                if tile == o:
                    if others[o][1] == 'Start':
                        start_pos = (x*64, y*64)
                    if others[o][0] != 'none':  
                        items.append(thing(x*64, y*64, 24, 50, 16, 16, pygame.image.load('data/images/' + others[o][0]),others[o][1] ))
            x += 1
        y += 1
    player.set_pos(start_pos[0], start_pos[1])
    
load_level(levels[current_level])
splash_screen()

while True: # game loop
    display.blit(background,(bgMovex, bgMovey)) # clear screen by filling it with background image
    for i in items: # Draw things that are not part of the background
        display.blit(i.img,(i.x + bgMovex, i.y + bgMovey))
    if screenTextTimer >0: #display text on the center of the screen for a short time
        text = font1.render(screenText,1,(255,255,0))
        display.blit(text, (int(SIZE[0]/2) - int(text.get_width() / 2),200))
        screenTextTimer -= 1

    scroll = (bgMovex * -1, bgMovey * -1)
    # Change the offset for the background based on player position
    if player.x + bgMovex > 670:
        bgMovex += int(670 - (player.x + bgMovex))
    if player.y + bgMovey > 390:
        bgMovey += int(390 - (player.y + bgMovey))
    if player.x + bgMovex < 610:
        bgMovex -= int((player.x + bgMovex) - 610)
    if player.y + bgMovey < 330:
        bgMovey -= int((player.y + bgMovey) - 330)
   
    if bgMovex > 0:
        bgMovex = 0
    if bgMovey > 0:
        bgMovey = 0
    if bgMovex < (bgSize[0] - SIZE[0]) * -1:
        bgMovex = (bgSize[0] - SIZE[0]) * -1
    if bgMovey < (bgSize[1] - SIZE[1]) * -1:
        bgMovey = (bgSize[1] - SIZE[1]) * -1
      
    player_movement = [0,0]
    if jumping:
        player_movement[0] += jumping_momentum
    else:
        player_movement[0] += momentum
    player_movement[1] += vertical_momentum
    vertical_momentum += 0.5 # Gravity
    if vertical_momentum > 15:
        vertical_momentum = 15
     
    for mon in monsters:
        if mon.momentum > 0:
            mon.ent.set_flip(False)
            mon.ent.set_action('walk')
        if mon.momentum < 0:
            mon.ent.set_flip(True)
            mon.ent.set_action('walk')
        mon_collision = mon.ent.move((mon.momentum, 0), tile_rects)
    
        if (mon_collision['left'] == True or mon_collision['right'] == True):
            mon.momentum *=  -1
        mon.ent.change_frame(1) #Animate a frame
        mon.ent.display(display,scroll)

        if e.collision_test(player.rect(),[mon.ent.rect()]) and alive and mon.momentum != 0: 
            if vertical_momentum > 3:
                mon.ent.set_action('dead')
                splatSound.play()
                mon.momentum = 0
            else:
                spikeSound.play()
                screenText = "Try Again"
                screenTextTimer = 120
                alive = False
        
    if alive:
        if player_movement[0] == 0:
            player.set_action('idle')
        if player_movement[0] > 0:
            player.set_flip(False)
            player.set_action('run')
        if player_movement[0] < 0:
            player.set_flip(True)
            player.set_action('run')
        if jumping or vertical_momentum > 3:
            player.set_action('jump')
        
        collision_types = player.move(player_movement,tile_rects) # Move the player and return collisions
    else:
        player.set_action('dead')
        collision_types = player.move((0, 0),[])

    if collision_types['top'] == True:
        vertical_momentum = 0

    if (collision_types['left'] == True or collision_types['right'] == True) and jumping and air_timer >6:
        moving_right = not moving_right
        moving_left = not moving_left
        jumping_momentum = jumping_momentum  * -1 #bounce off wall

    if collision_types['bottom'] == True:
        air_timer = 0
        vertical_momentum = 0
        if jumping == True:
            jumping = False
            moving_left = moving_right = False
    else:
        air_timer += 1

    keys = pygame.key.get_pressed() # get keys pressed for commands

    if e.collision_test(player.rect(),kill_tiles) and alive: #Test for deadly collisions
        spikeSound.play()
        screenText = "Try Again"
        screenTextTimer = 120
        alive = False
    if not alive and screenTextTimer == 0:
        player.set_pos(start_pos[0], start_pos[1])
        alive = True
    for item in items: # Item collisions
        if e.collision_test(player.rect(),[item.hitBox]):
            if item.name == 'Gold':
                screenText = "Gold"
                screenTextTimer = 60
                goldSound.play()
                invent["Gold"] +=1
                items.pop(items.index(item))
            if item.name == 'Key':
                screenText = "Key"
                screenTextTimer = 60
                goldSound.play()
                invent["Keys"] +=1
                items.pop(items.index(item))
            if item.name == 'Door':
                if invent["Keys"] and not door_unlocked:
                    screenText = "Door Unlocked, Press up to open"
                    screenTextTimer = 60
                    item.img = unlocked_door_img
                    door_unlocked = True
                    invent["Keys"] -= 1
                elif not door_unlocked:
                    screenText = "Door Locked"
                    screenTextTimer = 60
                if keys[pygame.K_UP] and door_unlocked:
                    door_unlocked = False
                    current_level += 1
                    load_level(levels[current_level])
            if item.name == 'Exit':
                end_screen()
                invent["Gold"] = 0
                current_level = 0
                load_level(levels[current_level])
                
    if display_invent: # Display Inventory
        text = font2.render("Inventory",1,(200,200,200))
        display.blit(text, (int(SIZE[0]-100) - int(text.get_width() / 2),50))
        space = 100
        for stuff in invent:
            num = str(invent[stuff])
            text = font2.render(stuff + " " + num,1,(200,200,200) )
            display.blit(text, (int(SIZE[0]-100) - int(text.get_width() / 2),space))
            space += 50

    player.change_frame(1) #Animate a frame
    player.display(display,scroll)
    
    for event in pygame.event.get(): # event loop
        if event.type == QUIT:
            pygame.quit()
            sys.exit()
            
        if event.type == VIDEORESIZE:
            if not fullscreen:
                window_size = (event.w,  event.h)
                screen = pygame.display.set_mode(window_size, pygame.RESIZABLE)

        if event.type == KEYDOWN:    
            if event.key == K_RETURN:
                fullscreen = not fullscreen
                if fullscreen:
                    screen_size = window_size
                    window_size = monitor_size
                    screen = pygame.display.set_mode(monitor_size, pygame.FULLSCREEN)
                else:
                    window_size = screen_size
                    screen = pygame.display.set_mode(window_size, pygame.RESIZABLE)
                    
            if event.key == K_i:
                display_invent = not display_invent
            
            if event.key == K_ESCAPE:
                window_size = screen_size
                screen = pygame.display.set_mode(window_size, pygame.RESIZABLE)
            
                  
    if keys[pygame.K_SPACE]: #Grabbed the keys pressed earlier
        if air_timer < 2 and not jumping:
            jumpSound.play()
            vertical_momentum = -15
            jumping_momentum = momentum
            jumping = True
        elif (collision_types['left'] == True or collision_types['right'] == True) and jumping and air_timer >10:
            air_timer = 0
            jumpSound.play()
            vertical_momentum = -15
   
    if keys[pygame.K_RIGHT]:
        moving_right = True
        moving_left = False
        momentum = SPEED
        if jumping_momentum <= momentum:
            jumping_momentum = jumping_momentum + .2
    elif keys[pygame.K_LEFT]:
        moving_left = True
        moving_right = False
        momentum = SPEED * -1
        if jumping_momentum >= momentum:
            jumping_momentum = jumping_momentum - .2
    else:
        moving_left = False
        moving_right = False
        momentum = 0

        
    screen.blit(pygame.transform.scale(display,window_size),(0,0))
    pygame.display.update()
    clock.tick(60)
    #print(clock.get_fps())
